

Option Strict Off
Option Explicit On


Friend Class Form1


Inherits System.Windows.Forms.Form


Private bLoaded As Boolean


Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
	
	' Form's KeyPreview is set to True, to catch keyboard action
	
	' Fill the BorderStyle cboBox
	With cboBorderStyle
		Call .Items.Add("zmbNone")
		Call .Items.Add("zmbFixedSingle")
		.SelectedIndex = Zoom1.BorderStyle
	End With
	
	' Fill the ShowBars cboBox
	With cboShowBars
		Call .Items.Add("zmsNone")
		Call .Items.Add("zmsLeft")
		Call .Items.Add("zmsTop")
		Call .Items.Add("zmsBoth")
		.SelectedIndex = Zoom1.ShowBars
	End With
	
	' ArrowColor
	With cboArrowColor
		Call .Items.Add("Yellow")
		Call .Items.Add("Red")
		Call .Items.Add("Green")
		Call .Items.Add("Blue")
		.SelectedIndex = Zoom1.ArrowColor
	End With
	
	' Initialize control
	With Zoom1
		.Factor = 10
		.HasGrid = True
		.ShowMarkers = True
	End With
	
	' Set the controls
	Call SetControls()
	
	bLoaded = True

End Sub

Private Sub Form1_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize
	
  On Error Resume Next
	
	If WindowState = System.Windows.Forms.FormWindowState.Minimized Then Exit Sub
	
	' Set controls position and size
	Zoom1.Width = VB6.TwipsToPixelsX((VB6.PixelsToTwipsX(ClientRectangle.Width) - VB6.PixelsToTwipsX(picRight.Width) - 90))
	Zoom1.Height = VB6.TwipsToPixelsY((VB6.PixelsToTwipsY(ClientRectangle.Height) - VB6.PixelsToTwipsY(picBottom.Height) - 90))
	
End Sub

' Moves the markers by pressing Ctrl/Shift and arrow keys
Private Sub Form1_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	' If the Ctrl key is pressed
	If Shift = VB6.ShiftConstants.CtrlMask Then
		' Check the pressed key
		Select Case KeyCode
			' Left arrow
			Case System.Windows.Forms.Keys.Left
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmTopA, ICZoom.ezmMarkerPos.zmpDecrease)
				' Right arrow
			Case System.Windows.Forms.Keys.Right
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmTopA, ICZoom.ezmMarkerPos.zmpIncrease)
				' Up arrow
			Case System.Windows.Forms.Keys.Up
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmLeftA, ICZoom.ezmMarkerPos.zmpDecrease)
				' Down arrow
			Case System.Windows.Forms.Keys.Down
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmLeftA, ICZoom.ezmMarkerPos.zmpIncrease)
		End Select
	End If
	
	' If the Shift key is pressed
	If Shift = VB6.ShiftConstants.ShiftMask Then
		' Check the pressed key
		Select Case KeyCode
			' Left arrow
			Case System.Windows.Forms.Keys.Left
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmTopB, ICZoom.ezmMarkerPos.zmpDecrease)
				' Right arrow
			Case System.Windows.Forms.Keys.Right
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmTopB, ICZoom.ezmMarkerPos.zmpIncrease)
				' Up arrow
			Case System.Windows.Forms.Keys.Up
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmLeftB, ICZoom.ezmMarkerPos.zmpDecrease)
				' Down arrow
			Case System.Windows.Forms.Keys.Down
				' Move marker into position
				Call Zoom1.MarkerMove(ICZoom.ezmMarkers.zmmLeftB, ICZoom.ezmMarkerPos.zmpIncrease)
		End Select
	End If
	
End Sub

' Zooms In/Out by pressing +/-
Private Sub Form1_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress

  Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
	
	' Check the pressed key
	Select Case KeyAscii
		' +
		Case 43
			If scrFactor.Value < 100 Then
				' Increase the zoom factor
				scrFactor.Value = (scrFactor.Value + 1)
			End If
			' -
		Case 45
			If scrFactor.Value > 1 Then
				' Decrease the zoom factor
				scrFactor.Value = (scrFactor.Value - 1)
			End If
	End Select
	
	eventArgs.KeyChar = Chr(KeyAscii)

	If KeyAscii = 0 Then
		eventArgs.Handled = True
	End If

End Sub

' Freezes/UnFreezes the view by pressing Escape/BackSpace
Private Sub Form1_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	' Check the pressed key
	Select Case KeyCode
		' Escape
		Case System.Windows.Forms.Keys.Escape
			' Lock the zoom view
			Zoom1.Locked = True
			' BackSpace
		Case System.Windows.Forms.Keys.Back
			' UnLock the zoom view
			Zoom1.Locked = False
	End Select
	
End Sub




' #################### CONTROLS ####################

Private Sub cmdColor_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdColor.Click

  Dim Index As Short = cmdColor.GetIndex(eventSender)
	
  On Error GoTo Out
	
'	Dlg.Flags = &H3
	DlgColor.FullOpen = True
	DlgColor.Color = lblColor(Index).BackColor
	DlgColor.ShowDialog()
	
	Select Case Index
		Case 0
			Zoom1.ClrMarkersL = DlgColor.Color
		Case 1
			Zoom1.ClrMarkersT = DlgColor.Color
		Case 2
			Zoom1.ClrGridA = DlgColor.Color
		Case 3
			Zoom1.ClrGridB = DlgColor.Color
		Case 4
			Zoom1.ClrDivs = DlgColor.Color
	End Select
	
	lblColor(Index).BackColor = DlgColor.Color
	
	' Cancel was pressed
Out: 
	
End Sub

' Sets the BorderStyle of the control
Private Sub cboBorderStyle_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboBorderStyle.SelectedIndexChanged
	
	If Not bLoaded then Exit Sub
	
	Zoom1.BorderStyle = cboBorderStyle.SelectedIndex
	
End Sub

' Sets the ArrowColor property of the control
Private Sub cboArrowColor_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboArrowColor.SelectedIndexChanged
	
	If Not bLoaded then Exit Sub
	
	Zoom1.ArrowColor = cboArrowColor.SelectedIndex
	
End Sub

' Sets the ShowBars property of the control
Private Sub cboShowBars_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboShowBars.SelectedIndexChanged
	
	If Not bLoaded then Exit Sub
	
	Zoom1.ShowBars = cboShowBars.SelectedIndex
	
End Sub

Private Sub scrFactor_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles scrFactor.ValueChanged
	
  Dim iFactor As Integer
	
	' Get the zoom factor
	iFactor = scrFactor.Value
	
	' Update the label
	txtZoom.Text = CStr(iFactor)
	
	' Set the zoom factor
	Zoom1.Factor = iFactor

End Sub

' Sets the CurrentX property when the Enter key is pressed.
' If the X coord is out of the screen, no error will occure
' but the zoom area will not change
Private Sub txtX_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtX.KeyDown

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	If KeyCode = System.Windows.Forms.Keys.Return Then
		' Set the CurrentX coord
		Zoom1.CurrentX = Val(txtX.Text)
	End If
	
End Sub

' Sets the CurrentX property when the Enter key is pressed.
' Accepts only Numbers and Backspace
Private Sub txtX_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtX.KeyPress

  Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
	
	' If not a number key
	If KeyAscii > 31 And (KeyAscii < System.Windows.Forms.Keys.D0 Or KeyAscii > System.Windows.Forms.Keys.D9) Then
		' Cancel char type
		KeyAscii = 0
		Beep()
		' ENTER
		ElseIf KeyAscii = System.Windows.Forms.Keys.Return Then 
		' Set the CurrentX coord
		Call txtX_Leave(txtX, New System.EventArgs())
		' Cancel char type
		KeyAscii = 0
	End If
	
	eventArgs.KeyChar = Chr(KeyAscii)

	If KeyAscii = 0 Then
		eventArgs.Handled = True
	End If

End Sub

' If the X coord is out of the screen, no error will occure
' but the zoom area will not change
Private Sub txtX_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtX.Leave
	
	' Set the CurrentY coord
	Zoom1.CurrentX = Val(txtX.Text)
	
	' Refresh the textbox
	txtX.Text = CStr(Zoom1.CurrentX)
	
End Sub

' Sets the CurrentY property when the Enter key is pressed.
' Accepts only Numbers and Backspace
Private Sub txtY_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtY.KeyPress

  Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
	
	' If not a number key
	If KeyAscii > 31 And (KeyAscii < System.Windows.Forms.Keys.D0 Or KeyAscii > System.Windows.Forms.Keys.D9) Then
		' Cancel char type
		KeyAscii = 0
		Beep()
		' ENTER
		ElseIf KeyAscii = System.Windows.Forms.Keys.Return Then 
		' Set the CurrentY coord
		Call txtY_Leave(txtY, New System.EventArgs())
		' Cancel char type
		KeyAscii = 0
	End If
	
	eventArgs.KeyChar = Chr(KeyAscii)

	If KeyAscii = 0 Then
		eventArgs.Handled = True
	End If

End Sub

' If the Y coord is out of the screen, no error will occure
' but the zoom area will not change
Private Sub txtY_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtY.Leave
	
	' Set the CurrentY coord
	Zoom1.CurrentY = Val(txtY.Text)
	
	' Refresh the textbox
	txtY.Text = CStr(Zoom1.CurrentY)
	
End Sub

' Accepts only Numbers and Backspace
Private Sub txtZoom_KeyPress(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyPressEventArgs) Handles txtZoom.KeyPress

  Dim KeyAscii As Short = Asc(eventArgs.KeyChar)
	
	' If not a number key
	If KeyAscii > 31 And (KeyAscii < System.Windows.Forms.Keys.D0 Or KeyAscii > System.Windows.Forms.Keys.D9) Then
		' Cancel char type
		KeyAscii = 0
		Beep()
		' ENTER
		ElseIf KeyAscii = System.Windows.Forms.Keys.Return Then 
		' Force a zoom update
		Call txtZoom_Leave(txtZoom, New System.EventArgs())
		' Cancel char type
		KeyAscii = 0
	End If
	
	eventArgs.KeyChar = Chr(KeyAscii)

	If KeyAscii = 0 Then
		eventArgs.Handled = True
	End If

End Sub

' Sets the Zoom factor of the control, by setting scrFactor
Private Sub txtZoom_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtZoom.Leave
	
  Dim iFactor As Integer
	
	' Get the zoom factor
	iFactor = Val(txtZoom.Text)
	
	' Error handling
	' -------------------------------
	If iFactor > (scrFactor.Maximum - scrFactor.LargeChange + 1) Then
		iFactor = (scrFactor.Maximum - scrFactor.LargeChange + 1)
		ElseIf iFactor < scrFactor.Minimum Then 
		iFactor = scrFactor.Minimum
	End If
	' -------------------------------
	
	' Set the scrollbar
	scrFactor.Value = iFactor
	
	' Refresh the textbox
	txtZoom.Text = CStr(iFactor)
	
End Sub

' Sets the FollowMouse property
Private Sub chkFollowMouse_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkFollowMouse.CheckStateChanged
	
	If Not bLoaded then Exit Sub
	
	Zoom1.FollowMouse = chkFollowMouse.CheckState
	
	' If we wish manual zoom
	If chkFollowMouse.CheckState Then ' And (Not bFrozen)
		' Start reading the CurrentX and CurrentY coords
		tmrMouse.Enabled = True
		' If we wish auto zoom
		Else
		' Stop reading the CurrentX and CurrentY coords
		tmrMouse.Enabled = False
	End If
	
End Sub

' Turns On/Off the grid
Private Sub chkGrid_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkGrid.CheckStateChanged
	
	If Not bLoaded then Exit Sub
	
	Zoom1.HasGrid = chkGrid.CheckState
	
End Sub

' Sets the frequency of divisions
Private Sub UD_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles UD.Scroll

	' Set property
	Zoom1.Step = eventArgs.newValue
	
	' Show value
	txtDivs.Text = CStr(Zoom1.Step)

End Sub

' Gets the CurrentX and CurrentY properties of the control
Private Sub tmrMouse_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tmrMouse.Tick
	
	txtX.Text = CStr(Zoom1.CurrentX)
	txtY.Text = CStr(Zoom1.CurrentY)
	
End Sub






































' #################### FUNCTIONS ####################

' Sets the form's controls to show the control's properties
Private Sub SetControls()
	
	lblColor(0).BackColor = Zoom1.ClrMarkersL
	lblColor(1).BackColor = Zoom1.ClrMarkersT
	lblColor(2).BackColor = Zoom1.ClrGridA
	lblColor(3).BackColor = Zoom1.ClrGridB
	lblColor(4).BackColor = Zoom1.ClrDivs
	
	chkGrid.CheckState = System.Math.Abs(Int(CDbl(Zoom1.HasGrid)))
	chkFollowMouse.CheckState = System.Math.Abs(Int(CDbl(Zoom1.FollowMouse)))
	
	scrFactor.Value = Zoom1.Factor
	UD.Value = Zoom1.Step
	txtZoom.Text = scrFactor.Value
	
	cboShowBars.SelectedIndex = Zoom1.ShowBars
	
End Sub






































' #################### EVENTS ####################

' Moves the markers by pressing Ctrl/Shift and arrow keys
Private Sub Zoom1_KeyDownEvent(ByVal sender As Object, ByVal e As AxICZoom.__Zoom_KeyDownEvent) Handles Zoom1.KeyDownEvent

	Call Form1_KeyDown(Me, New System.Windows.Forms.KeyEventArgs(e.KeyCode Or e.Shift * &H10000))
	
End Sub

' Zooms In/Out by pressing +/-
Private Sub Zoom1_KeyPressEvent(ByVal sender As Object, ByVal e As AxICZoom.__Zoom_KeyPressEvent) Handles Zoom1.KeyPressEvent
	
	Call Form1_KeyPress(Me, New System.Windows.Forms.KeyPressEventArgs(Chr(e.KeyAscii)))
	
End Sub

' Locks/UnLocks the view by pressing Escape/BackSpace
Private Sub Zoom1_KeyUpEvent(ByVal sender As Object, ByVal e As AxICZoom.__Zoom_KeyUpEvent) Handles Zoom1.KeyUpEvent
	
	Call Form1_KeyUp(Me, New System.Windows.Forms.KeyEventArgs(e.KeyCode Or e.Shift * &H10000))
	
End Sub

' A marker of the Top bar has been moved
Private Sub Zoom1_MarkerChangeX(ByVal sender As Object, ByVal e As AxICZoom.__Zoom_MarkerChangeXEvent) Handles Zoom1.MarkerChangeX
	
	' Show the distance
	txtDistX.Text = CStr(e.Distance)
	
End Sub

' A marker of the Left bar has been moved
Private Sub Zoom1_MarkerChangeY(ByVal sender As Object, ByVal e As AxICZoom.__Zoom_MarkerChangeYEvent) Handles Zoom1.MarkerChangeY
	
	' Show the distance
	txtDistY.Text = CStr(e.Distance)
	
End Sub


End Class